$(document).ready ->
  console.log('Hello, world!')

  $('.ticket-severity').on('click', handleSeverityClick)
  $('.ticket-status').on('click', handleStatusClick)

handleSeverityClick = (e, msg = 'Set ticket severity:') ->
  validSeverity = ['low', 'medium', 'high']
  newSeverity = prompt(msg, $('.ticket-severity > span').text())
  newSeverity = newSeverity.toLowerCase()

  if (newSeverity != null) and (newSeverity != '')
    if (newSeverity in validSeverity)
      console.log('Setting severity to ' + newSeverity)
      editLink = $('#ticketEditLink').attr('href') + '/severity'
      console.log('Sending data to ' + editLink)
      $.ajax({
        type: "POST",
        url: editLink,
        data:
          severity: newSeverity,
        dataType: 'json',
        success: (result) ->
          newSeverity = newSeverity.charAt(0).toUpperCase() + newSeverity.slice(1)
          $('.ticket-severity > span').text(newSeverity)
          updateTicketModified(result.updated_at)
          console.log('Ticket updated successfully.')
      })
    else
      console.log('Invalid severity entered')
      handleSeverityClick(e, 'Invalid severity; valid values are low, medium, and high.')


handleStatusClick = (e, msg = 'Set ticket status:') ->
  validStatus = ['open', 'closed', 'parked']
  newStatus = prompt(msg, $('.ticket-status > span').text())
  newStatus = newStatus.toLowerCase()

  if (newStatus != null) and (newStatus != '')
    if (newStatus in validStatus)
      console.log('Setting status to ' + newStatus)
      editLink = $('#ticketEditLink').attr('href') + '/status'
      console.log('Sending data to ' + editLink)
      $.ajax(
        type: "POST",
        url: editLink,
        data:
          status: newStatus,
        dataType: 'json',
        success: (result) ->
          newStatus = newStatus.charAt(0).toUpperCase() + newStatus.slice(1)
          $('.ticket-status > span').text(newStatus)
          updateTicketModified(result.updated_at)
          console.log('Ticket updated successfully.')
      )
    else
      console.log('Invalid status entered')
      handleStatusClick(e, 'Invalid status; valid values are open, closed, and parked.')

updateTicketModified = (date) ->
  $('.ticket-updated > span').text(date)
  console.log('Ticket update time is ' + date)
